Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 34983)
@@ -156,4 +156,9 @@
     <file alias="progress_poweroff_90px.png">images/progress_poweroff_90px.png</file>
     <file alias="progress_delete_90px.png">images/progress_delete_90px.png</file>
+    <file alias="progress_media_create_90px.png">images/progress_media_create_90px.png</file>
+    <file alias="progress_media_delete_90px.png">images/progress_media_delete_90px.png</file>
+    <file alias="progress_snapshot_create_90px.png">images/progress_snapshot_create_90px.png</file>
+    <file alias="progress_snapshot_restore_90px.png">images/progress_snapshot_restore_90px.png</file>
+    <file alias="progress_snapshot_discard_90px.png">images/progress_snapshot_discard_90px.png</file>
     <file alias="status_check_16px.png">images/status_check_16px.png</file>
     <file alias="status_check_32px.png">images/status_check_32px.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxMediaManagerDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxMediaManagerDlg.cpp	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxMediaManagerDlg.cpp	(revision 34983)
@@ -1081,5 +1081,5 @@
                 if (hardDisk.isOk())
                 {
-                    vboxProblem().showModalProgressDialog(progress, windowTitle(), ":/progress_delete_90px.png", this, true);
+                    vboxProblem().showModalProgressDialog(progress, windowTitle(), ":/progress_media_delete_90px.png", this, true);
                     if (!(progress.isOk() && progress.GetResultCode() == S_OK))
                     {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 34983)
@@ -1019,5 +1019,5 @@
         {
             /* Show the "Taking Snapshot" progress dialog */
-            vboxProblem().showModalProgressDialog(progress, machine.GetName());
+            vboxProblem().showModalProgressDialog(progress, machine.GetName(), ":/progress_snapshot_create_90px.png", 0, true);
 
             if (progress.GetResultCode() != 0)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 34983)
@@ -371,5 +371,5 @@
                                 {
                                     /* Show the progress dialog: */
-                                    vboxProblem().showModalProgressDialog(progress, machine.GetName());
+                                    vboxProblem().showModalProgressDialog(progress, machine.GetName(), ":/progress_snapshot_discard_90px.png", 0, true);
                                     if (progress.GetResultCode() != 0)
                                         vboxProblem().cannotRestoreSnapshot(progress, snapshot.GetName());
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp	(revision 34983)
@@ -536,6 +536,6 @@
     {
         /* Show the progress dialog */
-        vboxProblem().showModalProgressDialog (progress, mMachine.GetName(), "",
-                                               vboxProblem().mainWindowShown());
+        vboxProblem().showModalProgressDialog (progress, mMachine.GetName(), ":/progress_snapshot_restore_90px.png",
+                                               vboxProblem().mainWindowShown(), true);
 
         if (progress.GetResultCode() != 0)
@@ -582,6 +582,6 @@
     {
         /* Show the progress dialog */
-        vboxProblem().showModalProgressDialog (progress, mMachine.GetName(), "",
-                                               vboxProblem().mainWindowShown());
+        vboxProblem().showModalProgressDialog (progress, mMachine.GetName(), ":/progress_snapshot_discard_90px.png",
+                                               vboxProblem().mainWindowShown(), true);
 
         if (progress.GetResultCode() != 0)
@@ -653,6 +653,6 @@
         {
             /* Show the progress dialog */
-            vboxProblem().showModalProgressDialog (progress, mMachine.GetName(), "",
-                                                   vboxProblem().mainWindowShown());
+            vboxProblem().showModalProgressDialog (progress, mMachine.GetName(), ":/progress_snapshot_create_90px.png",
+                                                   vboxProblem().mainWindowShown(), true);
 
             if (progress.GetResultCode() != 0)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newhd/UINewHDWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newhd/UINewHDWzd.cpp	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newhd/UINewHDWzd.cpp	(revision 34983)
@@ -522,5 +522,5 @@
     }
 
-    vboxProblem().showModalProgressDialog(progress, windowTitle(), "", parentWidget());
+    vboxProblem().showModalProgressDialog(progress, windowTitle(), ":/progress_media_create_90px.png", this, true);
 
     if (progress.GetCanceled())
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp	(revision 34982)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp	(revision 34983)
@@ -497,5 +497,5 @@
     if (m_HardDisk.isOk())
     {
-        vboxProblem().showModalProgressDialog(progress, windowTitle(), ":/progress_delete_90px.png", this, true);
+        vboxProblem().showModalProgressDialog(progress, windowTitle(), ":/progress_media_delete_90px.png", this, true);
         if (progress.isOk() && progress.GetResultCode() == S_OK)
             success = true;